#include <mictcp.h>
#include <stdio.h>

#define MAX_SIZE 1000

#define COLOR_RED     "\x1b[31m"
#define COLOR_GREEN   "\x1b[32m"
#define COLOR_BOLD   "\x1b[1m"
#define COLOR_RESET   "\x1b[0m"

int main() {
    int sockfd;
    mic_tcp_sock_addr addr;
    mic_tcp_sock_addr remote_addr;
    char chaine[MAX_SIZE];

    addr.ip_addr = "127.0.0.1";
    addr.port = 1234;


    if ((sockfd = mic_tcp_socket(SERVER)) == -1) {
        printf("[TSOCK] Creation du socket MICTCP: "COLOR_RED"ERREUR"COLOR_RESET"\n");
        return 1;
    } else {
        printf("[TSOCK] Creation du socket MICTCP: "COLOR_GREEN"OK"COLOR_RESET"\n");
    }

    if (mic_tcp_bind(sockfd, addr) == -1) {
        printf("[TSOCK] Bind du socket MICTCP: "COLOR_RED"ERREUR"COLOR_RESET"\n");
        return 1;
    } else {
        printf("[TSOCK] Bind du socket MICTCP: "COLOR_GREEN"OK"COLOR_RESET"\n");
    }

    if (mic_tcp_accept(sockfd, &remote_addr) == -1) {
        printf("[TSOCK] Accept sur le socket MICTCP: "COLOR_RED"ERREUR"COLOR_RESET"\n");
        return 1;
    } else {
        printf("[TSOCK] Accept sur le socket MICTCP: "COLOR_GREEN"OK"COLOR_RESET"\n");
    }


    memset(chaine, 0, MAX_SIZE);

    printf(COLOR_BOLD"[TSOCK] Appuyez sur CTRL+C pour quitter ...\n"COLOR_RESET);

    while (1) {
        int rcv_size = 0;
        printf("\n[TSOCK] Attente d'une donnee, appel de mic_recv ...\n");
        rcv_size = mic_tcp_recv(sockfd, chaine, MAX_SIZE);
        printf("[TSOCK] Reception d'un message de taille : %d\n", rcv_size);
        printf("[TSOCK] Message Recu : "COLOR_BOLD"%s"COLOR_RESET, chaine);
    }
    return 0;
}
